<?php include 'settings.php'; ?><!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>FoxyCart Transaction Export</title>
	<link href="css/bootstrap.min.css" rel="stylesheet">
	<link rel="stylesheet" href="css/ui-lightness/jquery-ui-1.9.0.custom.min.css" />
	<style type="text/css">
		.progress {
			height:30px;
			margin-left:0;
		}
		.bar {
			line-height:30px;
			font-size:14px;
		}
		#progress-info,
		#time-remaining {
			text-align:right;
		}
	</style>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.8.2/jquery.min.js"></script>
	<script src="js/bootstrap.min.js"></script>
	<script src="js/jquery-ui-1.9.0.custom.min.js"></script>
	<script src="js/moment.1.7.2.min.js"></script>
	<script>
    $(function() {
    	jQuery("#date_filter_holder").hide();

    	jQuery("#date_filter").click(function() {
    		toggleDateFilter();
    	});

        $( "#transaction_date_filter_begin" ).datepicker({
            showOn: "both",
            buttonImage: "images/calendar.png",
            buttonImageOnly: true,
            dateFormat: "yy-mm-dd",
            defaultDate: "-1m",
            onSelect: function( selectedDate ) {
                $( "#transaction_date_filter_end" ).datepicker( "option", "minDate", selectedDate );
            }
        });
        $( "#transaction_date_filter_end" ).datepicker({
            showOn: "both",
            buttonImage: "images/calendar.png",
            buttonImageOnly: true,
            dateFormat: "yy-mm-dd",
        	maxDate: "1d",
            onSelect: function( selectedDate ) {
                $( "#transaction_date_filter_begin" ).datepicker( "option", "maxDate", selectedDate );
            }
        });

        toggleDateFilter();

        jQuery("form").submit(function() {
    		jQuery(this).removeClass("has-error");

        	jQuery(".validate").each(function() {
        		validateField(this);
        	})

        	validateDate();

        	if (!jQuery(this).hasClass("has-error")) {
	        	formData = jQuery("form").serialize();
	        	jQuery(".store_domain").html(jQuery("#store_domain").val());
	        	jQuery("#progressModal").modal({
	        		keyboard: false,
	        		backdrop: 'static'
	        	});

	        	// Reset the modal
		    	jQuery(".panel").hide();
		    	jQuery("#panel-start").show();
		    	jQuery("#progressbar").html("Initializing...").removeClass("bar-success bar-warning bar-danger").css("width", "100%").parent(".progress").addClass("progress-striped active");
				jQuery(".modal .btn").hide();
				jQuery("#btn-cancel").show();
				jQuery(".panel .errors").hide();
				jQuery("#progress-info, #time-remaining").html("");

	        	exportTransactions();
	        }

        	return false;
        });

        jQuery(".validate").change(function() {
        	validateField(this);
        });

        jQuery(".textDate").change(function() {
        	validateDate();
        });

        jQuery("#btn-cancel, #btn-close, #btn-manual").click(function() {
        	jQuery("#progressModal").modal('hide');
        	xhr.abort();
        });

        jQuery("#btn-download").click(function() {
        	jQuery("#panel-start").hide();
        	jQuery("#panel-remove, #btn-delete").show();
        });

        jQuery("#btn-delete").click(function() {
        	jQuery.ajax({
	    		url: 'do.php',
	    		dataType: 'json',
	    		data: 'action=delete&passphrase=' + jQuery("#passphrase").val() + '&filename=' + jQuery(this).data('filename'),
	    		success: function(data) {
	    			if (data.result == "SUCCESS") {
		    			jQuery("#panel-remove").hide();
		    			jQuery("#panel-complete").show();
		    			jQuery(".modal .btn").hide();
		    			jQuery("#btn-close").show();
	    			} else {
		    			jQuery(".modal .btn").hide();
		    			jQuery("#btn-manual").html(data.buttontext).show();
		    			jQuery("#panel-remove .errors").html("<li>" + data.message + "</li>");
		    			jQuery("#panel-remove .alert-error").show();
	    			}
	    		}
	    	});
        	return false;
        });

    });

    function toggleDateFilter() {
    	if (jQuery("#date_filter").is(":checked")) {
    		jQuery("#date_filter_holder").show();
    	} else {
    		jQuery("#date_filter_holder").hide();
    	}
    }

    function validateField(el) {
    	var el = jQuery(el);

    	if (el.val() == "") {
    		triggerValidationState(el, "error");
    	} else {
    		triggerValidationState(el);
    	}
    }

    function validateDate() {
		var from = jQuery("#transaction_date_filter_begin");
    	var to = jQuery("#transaction_date_filter_end");

    	if (jQuery("#date_filter").is(":checked")) {
	    	if (from.val() == "" || to.val() == "") {
	    		triggerValidationState(from, "error");
    			return false;
	    	}
    	}

    	triggerValidationState(from);
    }

    function triggerValidationState(el, state) {
    	var state = state || "";
    	el.parents(".control-group").removeClass("error success").addClass(state);

    	if (state == "error") {
    		jQuery("form").addClass("has-error");
    	}
    }

    jQuery.ajaxSetup ({
	    cache: false
	});

    function exportTransactions(result) {
    	//console.log(result);
	var ajaxData = formData;
    	var pagination_start = 0;
    	var entries_per_page = 30;
    	if (result != null) {
    		if (versionCompare(result.store_version, "0.7.2") > -1) {
    			// 0.7.2 or newer
	    		pagination_start = (parseFloat(result.statistics.pagination_end) + 1);
	    		ajaxData += "&entries_per_page=300";
	    		entries_per_page = 300;
	    	} else {
	    		pagination_start = parseFloat(result.statistics.pagination_end);
	    	}
    	} else {
    		// Must be first run, track the total time
    		m_start_all = moment();
    	}

    	ajaxData += "&pagination_start=" + pagination_start;

    	var m_start = moment();

    	xhr = jQuery.ajax({
    		url: 'process.php',
    		dataType: 'json',
    		data: ajaxData,
    		success: function(data) {
    			if (data.result == "SUCCESS") {
    				var m_end = moment();
    				var filtered_total = parseFloat(data.statistics.filtered_total);
    				var pagination_end = parseFloat(data.statistics.pagination_end);
	    			if (filtered_total > pagination_end) {
	    				// Calculate time remaining
	    				var m_diff = m_end.diff(m_start, "seconds");
	    				var pages_left = Math.ceil((filtered_total - pagination_end)/entries_per_page);
	    				var m_fromnow = moment.duration(m_diff * pages_left, "seconds").humanize();
	    				jQuery("#time-remaining").html(m_fromnow + " remaining");

	    				var progress = Math.floor((pagination_end/filtered_total) * 100);
	    				jQuery("#progressbar").html(progress + "%").css("width", progress + "%");
	    				jQuery("#progress-info").html(pagination_end + " of " + filtered_total + " exported");
	    				exportTransactions(data);
	    			} else {
	    				// Export is done!
	    				jQuery("#progressbar").html("Complete!").css("width", "100%").addClass("bar-success").parent('.progress').removeClass("active progress-striped");
	    				jQuery("#progress-info").html(filtered_total + " of " + filtered_total + " exported");
	    				// hour: 3600
	    				// minute: 60
	    				var total_time = [];
	    				var m_diff = m_end.diff(m_start_all, "seconds");
	    				if ((m_diff/3600) >= 1) {
	    					var hours = Math.floor(m_diff/3600);
	    					hours += (hours > 1) ? " hours" : " hour";
	    					total_time.push(hours)
	    					m_diff = m_diff%3600;
	    				}
	    				if ((m_diff/60) >= 1) {
	    					var minutes = Math.floor(m_diff/60);
	    					minutes += (minutes > 1) ? " minutes" : " minute";
	    					total_time.push(minutes)
	    					m_diff = m_diff%60;
	    				}
	    				if (m_diff > 0) {
	    					var seconds = m_diff;
	    					seconds += (seconds > 1) ? " seconds" : " second";
	    					total_time.push(seconds)
	    					m_diff = m_diff%3600;
	    				}
	    				jQuery("#time-remaining").html("Total time: " + total_time.join(", "));
	    				jQuery("#file-size").html(data.file.size);
	    				jQuery("#btn-download").show().attr('href', "do.php?action=download&filename=" + data.file.name);
	    				jQuery("#btn-delete").data('filename', data.file.name);
	    				jQuery("#btn-cancel").hide();
	    			}
	    		} else {
	    			jQuery("#panel-error .errors").html("");
	    			for (var m in data.messages) {
	    				jQuery("#panel-error .errors").append("<li>" + data.messages[m] + "</li>");
	    			}
	    			jQuery(".errors").show();
	    			jQuery("#panel-start").hide();
	    			jQuery("#panel-error").show();
	    			jQuery(".modal .btn").hide();
	    			jQuery("#btn-close").show();
	    		}
    		}
    	});
    }

    // @author Alexey Bass (https://gist.github.com/1115557)
    versionCompare = function(left, right) {
	    if (typeof left + typeof right != 'stringstring')
	        return false;

	    var a = left.split('.')
	    ,   b = right.split('.')
	    ,   i = 0, len = Math.max(a.length, b.length);

	    for (; i < len; i++) {
	        if ((a[i] && !b[i] && parseInt(a[i]) > 0) || (parseInt(a[i]) > parseInt(b[i]))) {
	            return 1;
	        } else if ((b[i] && !a[i] && parseInt(b[i]) > 0) || (parseInt(a[i]) < parseInt(b[i]))) {
	            return -1;
	        }
	    }

	    return 0;
	}
	</script>
</head>
<body>
	<div class="container">
		<h1>FoxyCart Transaction Export</h1>
		<p>Use the following facility to export transactions from your FoxyCart store as a single file</p>
		<div class="alert alert-block">
		  <button type="button" class="close" data-dismiss="alert">×</button>
		  <h4>Warning</h4>
		  This file can provide access to your store's complete transactional information. The security precautions for access to this file are your responsibility. We recommend at least placing this setup in a password protected area of your server.
		</div>
		<ol>
			<form action="process.php" class="form-horizontal">
				<div class="control-group">
					<label class="control-label" for="store_domain">Store Domain:</label>
					<div class="controls">
						<div class="input-prepend">
							<span class="add-on">https://</span>
							<input type="text" name="store_domain" id="store_domain" class="validate" value="<?php echo $storeDomain; ?>" />
						</div>
						<span class="help-block">Example: <code>yourdomain.foxycart.com</code> or <code>secure.yourdomain.com</code></span>
					</div>
				</div>
				<div class="control-group">
					<label class="control-label" for="passphrase">Passphrase:</label>
					<div class="controls">
						<input type="text" name="passphrase" id="passphrase" class="validate"  />
						<span class="help-block">The secret phrase you set when setting up this script</span>
					</div>
				</div>
				<div class="control-group">
					<div class="controls">
						<label class="checkbox" for="date_filter"><input type="checkbox" name="date_filter" id="date_filter" value="1" /> Filter by date range</label>
					</div>
				</div>
				<div id="date_filter_holder" class="control-group">
					<label class="control-label" for="transaction_date_filter_begin">Transaction Date:</label>
					<div class="controls controls-row">
						<div class="input-prepend">
							<span class="add-on">From</span>
							<input type="text" name="transaction_date_filter_begin" id="transaction_date_filter_begin" class="textDate">
						</div>
						&nbsp;&nbsp;
						<div class="input-prepend">
							<span class="add-on">To</span>
							<input type="text" name="transaction_date_filter_end" id="transaction_date_filter_end" class="textDate">
						</div>
					</div>
				</div>
				<div class="control-group">
					<label class="control-label" for="is_test_filter">Transaction Type:</label>
					<div class="controls">
						<select name="is_test_filter" id="is_test_filter">
							<option value="0" selected="selected">Live</option>
							<option value="1">Test</option>
							<option value="">Both</option>
						</select>
					</div>
				</div>

				<div class="control-group">
					<label class="control-label" for="hide_transaction_filter">Transaction Display Status:</label>
					<div class="controls">
						<select name="hide_transaction_filter" id="hide_transaction_filter">
							<option value="0" selected="selected">Visible</option>
							<option value="1">Hidden</option>
							<option value="">Both</option>
						</select>
					</div>
				</div>
				<div class="control-group">
					<label class="control-label" for="filetype">File Type:</label>
					<div class="controls">
						<select name="filetype" id="filetype">
							<option value="csv" selected="selected">Comma Separated</option>
							<option value="tab">Tab Delimited</option>
						</select>
					</div>
				</div>
				<div class="control-group">
					<div class="controls">
						<input type="hidden" name="includelineitems" value="0" />
						<label class="checkbox" for="includelineitems"><input type="checkbox" name="includelineitems" id="includelineitems" value="1" /> Include Line Items</label>
					</div>
				</div>
				<div id="submit" class="control-group">
					<div class="controls">
						<button type="submit" class="btn">Submit</button>
					</div>
				</div>
			</form>
		</ol>
	</div>

	<div class="modal hide fade in out" id="progressModal" tabindex="-1" role="dialog" aria-labelledby="progressModal" aria-hidden="true">
	  <div class="modal-header">
	    <h4>Exporting for <span class="store_domain"></span></h4>
	  </div>
	  <div class="modal-body">
	  	<div id="panel-start" class="panel">
		    <div class="progress progress-striped active">
				<div id="progressbar" class="bar" style="width: 100%;">Initializing...</div>
			</div>
			<p id="progress-info"></p>
			<p id="time-remaining"></p>
		</div>
		<div id="panel-error" class="panel" style="display:none;">
		    <div class="progress">
				<div class="bar bar-danger" style="width: 100%;">Error...</div>
			</div>
			<div class="alert alert-block">
			  <h4>Error</h4>
			  <ul class="errors">
			  </ul>
			</div>
		</div>
		<div id="panel-remove" class="panel" style="display:none;">
			<div class="alert alert-block">
			  <h4>Note</h4>
			  Now that you've downloaded your file, we highly recommend deleting the file that has just been created for you on your server. Otherwise, you'll be leaving unprotected copies of your customers private data on your server.
			</div>
			<div class="alert alert-error hide">
			  <h4>Error</h4>
			  <ul class="errors">
			  </ul>
			</div>
		</div>
		<div id="panel-complete" class="panel" style="display:none;">
			<div class="alert alert-success">
			  <h4>All done!</h4>
			  The file has successfully been deleted from the server.
			</div>
		</div>
	  </div>
	  <div
	  <div class="modal-footer">
	    <a href="#" id="btn-cancel" class="btn btn-danger">Cancel</a>
	  	<a href="#" id="btn-download" class="btn btn-success hide"><i class="icon-download-alt icon-white"></i> Download <small>(<span id="file-size"></span>)</small></a>
	  	<a href="#" id="btn-manual" class="btn btn-inverse hide">I've manually deleted the file</a>
	  	<a href="#" id="btn-delete" class="btn btn-danger hide"><i class="icon-remove icon-white"></i> Delete file</small></a>
	  	<a href="#" id="btn-close" class="btn hide">Close</a>
	  </div>
	</div>
</body>
</html>
